import { BaseBatchUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-batch-update-status.manager';
import { {{pascalCase name}}Entity } from '../../entities/{{dashCase name}}.entity';
import { EventTopics, validateRelations } from 'src/core/strings/constants/interface.constants';
import { {{pascalCase name}}Model } from '../../../data/models/{{dashCase name}}.model';
import { {{pascalCase name}}ChangeStatusEvent } from '../../entities/event/{{dashCase name}}-change-status.event';
import { BatchResult } from 'src/core/response/domain/ok-response.interface';
import { Injectable } from '@nestjs/common';

@Injectable()
export class BatchActive{{pascalCase name}}Manager extends BaseBatchUpdateStatusManager<{{pascalCase name}}Entity> {
  validateData(data: {{pascalCase name}}Entity): Promise<void> {
    return;
  }

  beforeProcess(): Promise<void> {
    return;
  }

  afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return {{pascalCase name}}Model;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: {{pascalCase name}}ChangeStatusEvent,
      },
    ];
  }

  getResult(): BatchResult {
    return this.result;
  }
}
